## http.class.sh

List of all functions in alphabetic order

### http()

[line: 97](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/http.class.sh#L97)

### http.addCurlparam()

```txt

Add an additional curl parameter

🟩 param  string  line to add, eg "Connection: keep-alive"

```

[line: 701](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/http.class.sh#L701)

### http.addHeader()

```txt

Add a line to the request header

🟩 param  string  line to add, eg "Connection: keep-alive"

```

[line: 690](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/http.class.sh#L690)

### http.dump()

```txt

Dump information about request and response

no params

```

[line: 585](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/http.class.sh#L585)

### http.flushCache()

```txt

Flush the cache

no params

```

[line: 884](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/http.class.sh#L884)

### http.getRequestAge()

```txt

Get age of the response in sec.
It is especially useful after responseImport

no param

returns integer  age of the response in sec

```

[line: 432](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/http.class.sh#L432)

### http.getRequestTs()

```txt

Get timestamp of the response as a Unix timestamp.

no param

returns string  the timestamp of the response

```

[line: 418](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/http.class.sh#L418)

### http.getResponse()

```txt

Get response body

no param

returns string  the response body

```

[line: 451](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/http.class.sh#L451)

### http.getResponseData()

```txt

Get curl data of this request with status, transferred bytes, speed, ...

no param

returns string  the response data

```

[line: 464](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/http.class.sh#L464)

### http.getResponseHeader()

```txt

Get response header

no param

returns string  the response header

```

[line: 477](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/http.class.sh#L477)

### http.getResponseRaw()

```txt

Get raw response (not available after import)

no params

no param

```

[line: 490](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/http.class.sh#L490)

### http.getStatus()

```txt

Get Http status as string OK|Redirect|Error

no params

```

[line: 501](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/http.class.sh#L501)

### http.getStatuscode()

```txt

Get Http status code of the request as 3 digit number

no params

```

[line: 514](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/http.class.sh#L514)

### http.help()

```txt

show a help text

no params

```

[line: 895](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/http.class.sh#L895)

### http.init()

```txt

Initialize the client

Initialize the client for a new request. Call this before any other
function. It will reset all variables.

```

[line: 118](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/http.class.sh#L118)

### http.isClientError()

```txt

Was the repsonse a client error (4xx)

no params

```

[line: 563](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/http.class.sh#L563)

### http.isError()

```txt

Was the repsonse a client error (4xx or 5xx)

no params

```

[line: 552](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/http.class.sh#L552)

### http.isOk()

```txt

Check: was response a 2xx status code?
output is a statuscode if it matches ... or empty
Additionally you can verify the return code

$? -eq 0 means YES
$? -ne 0 means NO

no params

```

[line: 530](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/http.class.sh#L530)

### http.isRedirect()

```txt

Was the repsonse a redirect?

no params

```

[line: 541](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/http.class.sh#L541)

### http.isServerError()

```txt

Was the repsonse a client error (5xx)

no params

```

[line: 574](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/http.class.sh#L574)

### http.loadcfg()

```txt

Load a config file

This function is marked as deprecated.
It will be removed in the future.

🟩 param  string  config file name

Sourcing that file will set the following vars
- RestApiUser
- RestApiPassword
- RestApiBaseUrl
- RestApiDocs

The function will then set the "internal" vars
- http_req__auth
- http_req__fullurl
- http_req__docs

```

[line: 293](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/http.class.sh#L293)

### http.makeRequest()

```txt

Execute the request

🔹 param  string  optional: method; GET|POST|PUT|DELETE|...
🔹 param  string  optional: full url
🔹 param  string  optional: request body

description:

This function does the following:

1. Check if to use a cache
2. If not cached, make the request
3. If cached, use the cached result

```

[line: 173](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/http.class.sh#L173)

### http.quit()

```txt

Show error message with last return code and quit with this exitcode

This function is used to quit the script with a meaningful error message
and the exit code of the last command.

The message is printed to STDERR and contains the return code.
If a documentation URL is known, it is printed as a hint.

The exit code is the one of the last command.
To prevent the script from exiting when this function is called from a
sourced file, the exit is commented out.

no params

```

[line: 260](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/http.class.sh#L260)

### http.responseDelete()

```txt

Delete an exported file; this is especially useful if you use
AUTOFILE functionality

🟩 param  string  filename with stored response

```

[line: 661](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/http.class.sh#L661)

### http.responseExport()

```txt

Export response to a file

🔹 param  string  optional: custom filename

```

[line: 619](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/http.class.sh#L619)

### http.responseImport()

```txt

Import a former response from a file

🟩 param  string  filename with stored response

```

[line: 637](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/http.class.sh#L637)

### http.setAccept()

```txt

set Accept request header and override default

🟩 param  string  accept header value, eg text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8

```

[line: 712](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/http.class.sh#L712)

### http.setAuth()

```txt

Set basic authentication
Without given parameter, authentication is removed

🔹 param  string  optional: USER:PASSWORD

```

[line: 728](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/http.class.sh#L728)

### http.setAuthorization()

```txt

Set authentication via Athorization header
Without given parameter, authorization is removed

🔹 param  string  optional: type, eg. Basic|Bearer|Negotiate
🔹 param  string  optional: token or encoded user + password

```

[line: 745](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/http.class.sh#L745)

### http.setBaseUrl()

```txt

Set a base url of an API
Remark: Then use http.setUrl to complet the url to request

🟩 param  string  url

```

[line: 772](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/http.class.sh#L772)

### http.setBody()

```txt

Set body to send for PUTs and POSTs

🟩 param  string  body

```

[line: 760](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/http.class.sh#L760)

### http.setCA()

```txt

set and unset CA cert file to use

🔹 param  string  optional: filename to use; no value to disable cafile

```

[line: 784](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/http.class.sh#L784)

### http.setCacheFile()

```txt

Set cache file

🟩 param  string  filename

```

[line: 873](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/http.class.sh#L873)

### http.setCacheTtl()

```txt

Set cache ttl in seconds

🟩 param  integer  ttl in seconds

```

[line: 862](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/http.class.sh#L862)

### http.setDebug()

```txt

Enable or disable debug mode

🟩 param  integer  0|1

```

[line: 795](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/http.class.sh#L795)

### http.setDocs()

[line: 801](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/http.class.sh#L801)

### http.setFullUrl()

```txt

Set a full url to request

🔹 param  string  optional: url

```

[line: 833](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/http.class.sh#L833)

### http.setInsecure()

```txt

Allow and disallow insecure connections

🔹 param  string  optional: 1 to enable insecure flag; no value to disable insecure flag

```

[line: 811](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/http.class.sh#L811)

### http.setMethod()

```txt

Set the method to use; GET|POST|PUT|DELETE|...

🟩 param  string  name of method

```

[line: 822](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/http.class.sh#L822)

### http.setUrl()

```txt

Complete the base url

🟩 param  string  url part behind base url

```

[line: 848](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/http.class.sh#L848)

- - -
Generated with [Bashdoc](https://github.com/axelhahn/bashdoc) v0.6
